ngx.req.read_body()
local args, err = ngx.req.get_post_args()
if not args then
    ngx.log(ngx.ERR, "failed to get post args")
    ngx.exit(ngx.HTTP_BAD_REQUEST)
end

if type(args) ~= "table" then
    ngx.log(ngx.ERR, "invalid args type")
    ngx.exit(ngx.HTTP_BAD_REQUEST)
end

local xdict    = {}
local username = ""

for key, val in pairs(args) do
    if key == "email" then
        username = tostring(val)
    elseif key == "password" then
        xdict["password"] = tostring(val)
    end
end

if not string.match(username, ".+@commandersact%.com$") then
    ngx.exit(ngx.HTTP_FORBIDDEN)
end

local res = ngx.location.capture("/thallium",
                { method = ngx.HTTP_POST,
                  body = require "cjson".encode(xdict),
                  vars = { username = string.gsub(username, "@", "-at-") }})

if res.status ~= ngx.HTTP_OK then
    ngx.log(ngx.ERR, "invalid username or password")
    ngx.exit(ngx.HTTP_UNAUTHORIZED)
end

args["password"] = ngx.var.FD_TOKEN

ngx.req.set_body_data(ngx.encode_args(args))
